# Copyright of Current Edition(TeXPen): Copyright (C) 2013  Amuwa King, <phd.wang.mch@gmail.com>
# Original TextPad: Copyright (C) 2013  Alex S. <alex_sr97@outlook.com>
# See License.txt file that comes with this distribution

QT       += core gui webkit network script
QT       += printsupport
TARGET    = texpen
TEMPLATE  = app

greaterThan(QT_MAJOR_VERSION, 4): {
    QT += widgets webkitwidgets
    DEFINES += QT5SDK
}

SOURCES += \
    sources/mainwindow.cpp \
    sources/main.cpp \
    sources/searchdialog.cpp \
    sources/widgetcreator.cpp \
    sources/colorschemes.cpp \
    sources/document.cpp \
    sources/syntaxhighlighter.cpp \
    sources/linenumbers.cpp \
    sources/settings.cpp \
    sources/structure.cpp \
    sources/equationviewer.cpp \
    sources/runcommand.cpp \
    sources/autocompletion.cpp \
    sources/runthread.cpp \
    sources/cmdconfigdialog.cpp \
    sources/qtexedit.cpp \
    3rd-party/hunspell/utf_info.cxx \
    3rd-party/hunspell/suggestmgr.cxx \
    3rd-party/hunspell/phonet.cxx \
    3rd-party/hunspell/hunzip.cxx \
    3rd-party/hunspell/hunspell.cxx \
    3rd-party/hunspell/hashmgr.cxx \
    3rd-party/hunspell/filemgr.cxx \
    3rd-party/hunspell/dictmgr.cxx \
    3rd-party/hunspell/csutil.cxx \
    3rd-party/hunspell/affixmgr.cxx \
    3rd-party/hunspell/affentry.cxx \
    3rd-party/ginger/ginger.cpp \
    sources/cstructuredata.cpp \
    sources/WebView.cpp \
    sources/AWLdict.cpp

HEADERS += \
    headers/mainwindow.h \
    headers/searchdialog.h \
    headers/highlighter.h  \
    headers/runthread.h \
    headers/cmdconfigdialog.h \
    headers/qtexedit.h \
    3rd-party/hunspell/w_char.hxx \
    3rd-party/hunspell/suggestmgr.hxx \
    3rd-party/hunspell/phonet.hxx \
    3rd-party/hunspell/langnum.hxx \
    3rd-party/hunspell/hunzip.hxx \
    3rd-party/hunspell/hunspell.hxx \
    3rd-party/hunspell/hunspell.h \
    3rd-party/hunspell/htypes.hxx \
    3rd-party/hunspell/hashmgr.hxx \
    3rd-party/hunspell/filemgr.hxx \
    3rd-party/hunspell/dictmgr.hxx \
    3rd-party/hunspell/csutil.hxx \
    3rd-party/hunspell/baseaffix.hxx \
    3rd-party/hunspell/atypes.hxx \
    3rd-party/hunspell/affixmgr.hxx \
    3rd-party/hunspell/affentry.hxx \
    headers/workThread.h \
    3rd-party/ginger/ginger.h \
    sources/cstructuredata.h \
    headers/WebView.h

RESOURCES += \
    images/images.qrc \
    3rd-party/dicts.qrc \
    Templates/templates.qrc \
    3rd-party/pdf-js.qrc \
    3rd-party/qwl.qrc

FORMS += \
    ui/cmdconfigdialog.ui

win32{
    RC_FILE = icon.rc
}else : macx {
    #ICON = images/icons/texpen.icns
    #QMAKE_MAC_SDK += ""
}

OTHER_FILES +=

